package com.jasamedika.medifirst2000.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.KemungkinanResikoTerjadiConverter;
import com.jasamedika.medifirst2000.dao.KemungkinanResikoTerjadiDao;
import com.jasamedika.medifirst2000.entities.KemungkinanResikoTerjadi;
import com.jasamedika.medifirst2000.entities.ProgramKerjaStrategis;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.KemungkinanResikoTerjadiService;
import com.jasamedika.medifirst2000.vo.KemungkinanResikoTerjadiVO;

@Service("KemungkinanResikoTerjadiService")
public class KemungkinanResikoTerjadiServiceImpl extends BaseVoServiceImpl implements KemungkinanResikoTerjadiService{

	@Autowired
	private KemungkinanResikoTerjadiDao kemungkinanDao;
	
	@Autowired
	private KemungkinanResikoTerjadiConverter kemungkinanConverter;
	
	@Override
	public KemungkinanResikoTerjadiVO add(KemungkinanResikoTerjadiVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public KemungkinanResikoTerjadiVO update(KemungkinanResikoTerjadiVO vo)
			throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public KemungkinanResikoTerjadiVO findById(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public List<KemungkinanResikoTerjadiVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String, Object> findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit,
			String sort, String dir) {
		return null;
	}

	@Override
	public Map<String, Object> findAll(Integer page, Integer take, String sort, String dir,
			Specification<KemungkinanResikoTerjadi> spec) {
		Direction direction=null;
		
		if(dir.equalsIgnoreCase("asc")){
			direction=Sort.Direction.ASC;
		}else{
			direction=Sort.Direction.DESC;
		}
		
		Pageable pageable = new PageRequest(page, take, direction, sort);
		Page<KemungkinanResikoTerjadi> resultPage = kemungkinanDao.findAll(spec, pageable);
		List<KemungkinanResikoTerjadi> resultData = resultPage.getContent();
		return constructMapReturn(resultData, resultPage.getTotalElements(), resultPage.getTotalPages());
	}

	@Override
	public Map<String, Object> save(KemungkinanResikoTerjadiVO vo) {
		Map<String,Object> result = new HashMap<String,Object>();
		KemungkinanResikoTerjadi model = kemungkinanConverter.transferVOToModel(vo, new KemungkinanResikoTerjadi());
		
		kemungkinanDao.save(model);
		
		return result;
	}

}
